<template>
  <el-container style="height: 100%">
    <el-header>
      <commonheader></commonheader>
    </el-header>
    <el-container>
      <el-aside width="auto">
        <commonaside></commonaside>
      </el-aside>
      <el-main>
        <div>
          <h2 align="center"><strong>修改餐品信息</strong></h2>
          <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="120px" class="demo-ruleForm">
            <el-form-item label="餐品名称" prop="foodName">
              <el-input style="width:300px" v-model="ruleForm.foodName" placeholder="请输入食品名称"></el-input>
            </el-form-item>
            <el-form-item label="餐品介绍" prop="foodIntroduction">
              <el-input type="textarea" v-model="ruleForm.foodIntroduction" placeholder="请输入餐品介绍"></el-input>
            </el-form-item>
            <el-form-item label="餐品图片" ref="uploadElement" prop="imageUrl">
              <el-input v-model="ruleForm.imageUrl" v-if="false"></el-input>
              <el-upload
                class="avatar-uploader"
                ref="upload"
                :show-file-list="false"
                action="/index/upload"
                :before-upload="beforeUpload"
                :on-change="handleChange"
                :auto-upload="false"
                :data="ruleForm">
                <img v-if="ruleForm.imageUrl" :src="ruleForm.imageUrl" class="avatar">
                <i v-else class="el-icon-plus avatar-uploader-icon"></i>
              </el-upload>
            </el-form-item>
            <el-form-item label="餐品类型" prop="foodCategory">
              <el-input style="width:300px" v-model="ruleForm.foodCategory" placeholder="请输入餐品类型"></el-input>
            </el-form-item>
            <el-form-item label="餐品价格" prop="foodPrice">
              <el-input-number style="width: 200px" v-model="ruleForm.foodPrice" placeholder="请输入餐品价格"></el-input-number>
            </el-form-item>
            <el-form-item label="餐品数量" prop="foodNumber">
              <el-input-number style="width: 200px" v-model="ruleForm.foodNumber" placeholder="请输入餐品数量"></el-input-number>
            </el-form-item>
            <el-form-item label="餐品卡路里" prop="foodCalorie">
              <el-input-number style="width: 200px" v-model="ruleForm.foodCalorie" placeholder="请输入卡路里值"></el-input-number>
            </el-form-item>
            <el-form-item label="餐品配料" prop="foodIngredient">
              <el-input type="textarea" v-model="ruleForm.foodIngredient" placeholder="请输入餐品配料"></el-input>
            </el-form-item>
            <el-row :gutter="10" v-for="(item,index) in ruleForm.ingredientList" :key="index" v-if="false">
              <div style="color:blue"> 配料 {{index+1}} :</div>
              <el-col>
                <el-form-item label="配料名" :prop="'ingredientList.' + index + '.ingredientName'" :rules="[{ trigger:'blur',message:'不能为空',required:true }]">
                  <el-input style="width:150px" type="text" v-model="item.ingredientName" placeholder="请输入配料名" clearable></el-input>
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="配料类别" :prop="'ingredientList.' + index + '.ingredientCategory'" :rules="[{ trigger:'blur',message:'不能为空',required:true }]">
                  <el-input  style="width:150px" type="phone" v-model="item.ingredientCategory" placeholder="请输入配料类别" clearable></el-input>
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="配料卡路里" :prop="'ingredientList.' + index + '.ingredientCalorie'" :rules="[{ trigger:'blur',message:'不能为空',required:true }]">
                  <el-input-number style="width:150px" v-model="item.ingredientCalorie" placeholder="请输入卡路里"></el-input-number>
                </el-form-item>
              </el-col>
              <el-col>
                <div>
                  <el-button type="text" v-if="ruleForm.ingredientList.length > 1" @click="removeRow(index)"><span style="color:red;">删除</span></el-button>
                </div>
              </el-col>
            </el-row>
            <el-form-item style="margin-top: 50px">
              <el-row>
                <el-col :span="9">
                  <el-button type="primary" size="mini" @click="submitForm('ruleForm')" :disabled="ruleForm.disabled===true">申请更改</el-button>
                </el-col>
                <el-col :span="9"  v-if="ruleForm.foodStatus === 0">
                  <el-button type="primary" size="mini" @click="resetStatus('ruleForm')" :disabled="ruleForm.disabled===true">上架餐品</el-button>
                </el-col>
                <el-col :span="9"  v-if="ruleForm.foodStatus === 1">
                  <el-button type="danger" size="mini" @click="resetStatus('ruleForm')" :disabled="ruleForm.disabled===true">下架餐品</el-button>
                </el-col>
              </el-row>
            </el-form-item>
          </el-form>
        </div>
      </el-main>
    </el-container>
  </el-container>
</template>

<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import modifyfood from '../services/modifyfood'
export default {
  name: 'addfood',
  components: {
    commonaside,
    commonheader
  },
  created () {
    // this.getfoodcheck()
    this.getfood()
  },
  data () {
    var validatapass = (rule, value, callback) => {
      if (value === '') {
        this.registerMsg = '输入不全'
        callback(new Error('请补全输入'))
      } else {
        callback()
      }
    }
    return {
      ruleForm: {
        shopId: 0,
        foodName: '',
        foodIntroduction: '',
        foodCategory: '',
        foodPrice: 0,
        foodNumber: 0,
        foodCalorie: 0,
        foodStatus: 0,
        imageUrl: '',
        foodIngredient: '',
        disabled: false
      },
      rules: {
        imageUrl: [
          {required: true, message: '请上传图片', validator: validatapass}
        ],
        foodIntroduction: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodName: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodStatus: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodCategory: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodPrice: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodNumber: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodCalorie: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        shopId: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        foodIngredient: [
          { trigger: 'blur', message: '不能为空', required: true }
        ]
      }
    }
  },
  methods: {
    async getfoodcheck () {
      try {
        await modifyfood.getcheck(this.$route.params.shopId, this.$route.params.foodId, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log('成功')
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          await this.$alert('商品不存在', '请求失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/browsefood/' + this.$route.params.shopId)
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('商品不存在', '请求失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.push('/browsefood/' + this.$route.params.shopId)
              }
            })
          }
          console.log(error.response.data.error)
        }
      }
    },
    async getfood () {
      try {
        const response = await modifyfood.getfoodinfo(this.$route.params.shopId, this.$route.params.foodId, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.ruleForm.foodName = response.data.data.food.foodName
        this.ruleForm.foodCalorie = response.data.data.food.foodCalorie
        this.ruleForm.foodCategory = response.data.data.food.foodCategory
        this.ruleForm.foodIntroduction = response.data.data.food.foodIntroduction
        this.ruleForm.foodPrice = response.data.data.food.foodPrice
        this.ruleForm.foodStatus = response.data.data.food.foodTakeStatus
        this.ruleForm.foodNumber = response.data.data.food.foodNumber
        this.ruleForm.imageUrl = response.data.data.food.foodImage
        this.ruleForm.foodIngredient = response.data.data.food.foodIngredient
        console.log('成功')
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          await this.$alert('商品不存在', '请求失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.go(-1)
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('商品不存在', '请求失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.go(-1)
              }
            })
          }
          console.log(error.response.data.error)
        }
      }
    },
    async submitForm (formName) {
      if (this.ruleForm.foodName === '' || this.ruleForm.foodIntroduction === '' || this.ruleForm.foodIngredient === '' || this.ruleForm.foodCategory === '' || this.ruleForm.imageUrl === '') {
        await this.$alert('有必填项未填！', '申请失败', {
          confirmButtonText: '确定',
          callback: action => {
            this.$message({
              type: 'info',
              message: `action: ${action}`
            })
          }
        })
        return
      }
      try {
        this.ruleForm.disabled = true
        const response = await modifyfood.postfoodchange({
          foodName: this.ruleForm.foodName,
          foodCalorie: this.ruleForm.foodCalorie,
          foodCategory: this.ruleForm.foodCategory,
          foodIntroduction: this.ruleForm.foodIntroduction,
          foodNumber: this.ruleForm.foodNumber,
          foodPrice: this.ruleForm.foodPrice,
          foodIngredient: this.ruleForm.foodIngredient,
          foodImage: this.ruleForm.imageUrl
        },
        {
          headers: {'Authorization': this.$store.state.token}
        }, this.$route.params.shopId, this.$route.params.foodId)
        if (response.data.code === 200) {
          await this.$alert('餐品更改申请成功！', '申请成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/browsemyshop/' + this.$route.params.shopId)
            }
          })
        } else {
          this.ruleForm.disabled = false
          this.error = response.data.msg
          await this.$alert(response.data.msg, '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        }
      } catch (error) {
        this.ruleForm.disabled = false
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          await this.$alert('Network Error', '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('图片过大，不能超过64KB', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        }
      }
    },
    async resetStatus (formName) {
      try {
        this.ruleForm.disabled = true
        const response = await modifyfood.postchangestatus({
          foodId: this.$route.params.foodId,
          foodTakeStatus: this.ruleForm.foodStatus ? 0 : 1
        },
        {
          headers: {'Authorization': this.$store.state.token}
        }, this.$route.params.shopId)
        if (response.data.code === 200) {
          await this.$alert('餐品更改申请成功！', '申请成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/browsemyshop/' + this.$route.params.shopId)
            }
          })
        } else {
          this.ruleForm.disabled = false
          this.error = response.data.msg
          await this.$alert(response.data.msg, '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        }
      } catch (error) {
        this.ruleForm.disabled = false
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          await this.$alert('Network Error', '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        } else {
          this.error = error.response.data.error
        }
      }
    },
    resetForm (formName) {
      this.ruleForm.imageUrl = ''
      this.ruleForm.foodCalorie = 0
      this.ruleForm.foodNumber = 0
      this.ruleForm.foodPrice = 0
      this.ruleForm.foodName = ''
      this.ruleForm.foodCategory = ''
      this.ruleForm.foodStatus = 0
      this.ruleForm.foodIntroduction = ''
      this.ruleForm.foodIngredient = ''
      this.ruleForm.shopId = 0
    },
    handleChange (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl = event.target.result
          // console.log(this.ruleForm.imageUrl)
        }
      })
    },
    handleChange2 (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl2 = event.target.result
          // console.log(this.ruleForm.imageUrl2)
        }
      })
    },
    beforeUpload (file) {

    },
    beforeUpload2 (file) {

    },
    addrow () {
      this.ruleForm.ingredientList.push({
        ingredientName: '',
        ingredientCategory: '',
        ingredientCalorie: 0
      })
    },
    removeRow (index) {
      this.ruleForm.ingredientList.splice(index, 1)
    }
  }
}
</script>

<style scoped>
.el-header {
  background-color: #333;
}
.el-main {
  padding-top: 0;
}
.demo-ruleForm {
  max-width: 800px;
  margin: 0 auto;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 130px;
  line-height: 130px;
  text-align: center;
}

.avatar {
  width: 178px;
  height: 130px;
  display: block;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}
</style>
